Table of Contents

Class Diff_MotionMagicExpoDutyCycle_Open

Namespace
CTRE.Phoenix6.Controls.Compound
Assembly
Phoenix6.Hardware.dll

Requires Phoenix Pro and CANivore; Differential control with Motion MagicĀ® Expo average target and duty cycle difference target.

public sealed class Diff_MotionMagicExpoDutyCycle_Open : ControlRequest, ICloneable
Inheritance
Diff_MotionMagicExpoDutyCycle_Open
Implements
Inherited Members

Constructors

Diff_MotionMagicExpoDutyCycle_Open(MotionMagicExpoDutyCycle, DutyCycleOut)

Requires Phoenix Pro and CANivore; Differential control with Motion MagicĀ® Expo average target and duty cycle difference target.

Average MotionMagicExpoDutyCycle request of the mechanism. Differential DutyCycleOut request of the mechanism.
public Diff_MotionMagicExpoDutyCycle_Open(MotionMagicExpoDutyCycle AverageRequest, DutyCycleOut DifferentialRequest)

Parameters

AverageRequest MotionMagicExpoDutyCycle
DifferentialRequest DutyCycleOut

Fields

AverageRequest

Average MotionMagicExpoDutyCycle request of the mechanism.

public MotionMagicExpoDutyCycle AverageRequest

Field Value

MotionMagicExpoDutyCycle

DifferentialRequest

Differential DutyCycleOut request of the mechanism.

public DutyCycleOut DifferentialRequest

Field Value

DutyCycleOut

UpdateFreqHz

The frequency at which this control will update. This is designated in Hertz, with a minimum of 20 Hz (every 50 ms) and a maximum of 1000 Hz (every 1 ms). Some update frequencies are not supported and will be promoted up to the next highest supported frequency.

If this field is set to 0 Hz, the control request will be sent immediately as a one-shot frame. This may be useful for advanced applications that require outputs to be synchronized with data acquisition. In this case, we recommend not exceeding 50 ms between control calls.
public double UpdateFreqHz

Field Value

double

Properties

Name

Name of this control request.

public string Name { get; }

Property Value

string

Methods

Clone()

Creates a copy of this control request.

public Diff_MotionMagicExpoDutyCycle_Open Clone()

Returns

Diff_MotionMagicExpoDutyCycle_Open

GetControlInfo()

Gets information about this control request.

public Dictionary<string, string> GetControlInfo()

Returns

Dictionary<string, string>

Dictionary of control parameter names and corresponding applied values

SendRequest(string, uint)

Sends this request out over CAN bus to the device for the device to apply.

public StatusCode SendRequest(string network, uint deviceHash)

Parameters

network string

Network to send request over

deviceHash uint

Device to send request to

Returns

StatusCode

Status of the send operation

ToString()

Provides the string representation of this object.

public override string ToString()

Returns

string

WithAverageRequest(MotionMagicExpoDutyCycle)

Modifies this Control Request's AverageRequest parameter and returns itself for method-chaining and easier to use request API.

Average MotionMagicExpoDutyCycle request of the mechanism.
public Diff_MotionMagicExpoDutyCycle_Open WithAverageRequest(MotionMagicExpoDutyCycle newAverageRequest)

Parameters

newAverageRequest MotionMagicExpoDutyCycle

Parameter to modify

Returns

Diff_MotionMagicExpoDutyCycle_Open

Itself

WithDifferentialRequest(DutyCycleOut)

Modifies this Control Request's DifferentialRequest parameter and returns itself for method-chaining and easier to use request API.

Differential DutyCycleOut request of the mechanism.
public Diff_MotionMagicExpoDutyCycle_Open WithDifferentialRequest(DutyCycleOut newDifferentialRequest)

Parameters

newDifferentialRequest DutyCycleOut

Parameter to modify

Returns

Diff_MotionMagicExpoDutyCycle_Open

Itself

WithUpdateFreqHz(double)

Sets the frequency at which this control will update. This is designated in Hertz, with a minimum of 20 Hz (every 50 ms) and a maximum of 1000 Hz (every 1 ms). Some update frequencies are not supported and will be promoted up to the next highest supported frequency.

If this field is set to 0 Hz, the control request will be sent immediately as a one-shot frame. This may be useful for advanced applications that require outputs to be synchronized with data acquisition. In this case, we recommend not exceeding 50 ms between control calls.
public Diff_MotionMagicExpoDutyCycle_Open WithUpdateFreqHz(double newUpdateFreqHz)

Parameters

newUpdateFreqHz double

Parameter to modify

Returns

Diff_MotionMagicExpoDutyCycle_Open

Itself